C        Generated by TAPENADE     (INRIA, Ecuador team)
C  Tapenade 3.16 (develop) - 15 Jan 2021 14:26
C
C  Differentiation of calcst in reverse (adjoint) mode (with options i4 dr8 r8):
C   gradient     of useful results: crtot cntot crsax cnsax
C   with respect to varying inputs: alfa crtot cntot
C GETFILE
C
C
C
C ==================== addition wrapper helper programs ==============
C
      SUBROUTINE CALCST_B()
      INCLUDE 'AVL.INC'
      INCLUDE 'AVL_ad_seeds.inc'
      CHARACTER*50 satype
      REAL wrot_rx(3), wrot_rz(3), wrot_a(3)
      REAL crsax_u(numax), cmsax_u(numax), cnsax_u(numax), crsax_d(ndmax
     +     ), cmsax_d(ndmax), cnsax_d(ndmax), crsax_g(ngmax), cmsax_g(
     +     ngmax), cnsax_g(ngmax)
      REAL dir
      EXTERNAL GETSA
      REAL ca
      REAL ca_diff
      INTRINSIC COS
      REAL sa
      REAL sa_diff
      INTRINSIC SIN
      REAL rx
      REAL ry
      REAL rz
      REAL crsax_a
      REAL cnsax_a
      INTEGER k
      REAL cl_al
      REAL cm_al
      REAL cr_rz
      REAL cn_be
      INTRINSIC ABS
      REAL bb
      REAL cr_be
      REAL cn_rz
      REAL abs0
      REAL(kind=8) temp_diff
C
      CALL GETSA(lnasa_sa, satype, dir)
C CALL VINFAB
C CALL AERO
C
C---- set freestream velocity components from alpha, beta
C
C---- calculate forces and sensitivities
C
C---- set stability-axes rates (RX,RY,RZ) in terms of body-axes rates
      ca = COS(alfa)
      sa = SIN(alfa)
C
C
C---- now vice-versa, and set sensitivities (which is what's really needed)
Cc    WROT(1)    =  RX*CA - RZ*SA
Cc    WROT(2)    =  RY
Cc    WROT(3)    =  RZ*CA + RX*SA
C
C
C
C!! = -WROT(3)
C!! =  WROT(1)
C
C
      temp_diff = dir*cnsax_diff
      cntot_diff = cntot_diff + ca*temp_diff
      ca_diff = cntot*temp_diff
      crtot_diff = crtot_diff - sa*temp_diff
      sa_diff = -(crtot*temp_diff)
      temp_diff = dir*crsax_diff
      crtot_diff = crtot_diff + ca*temp_diff
      ca_diff = ca_diff + crtot*temp_diff
      cntot_diff = cntot_diff + sa*temp_diff
      sa_diff = sa_diff + cntot*temp_diff
      alfa_diff = COS(alfa)*sa_diff - SIN(alfa)*ca_diff
C
C        WRITE(*,8401) XNP
 8401 FORMAT(/'Neutral point  Xnp =',f11.6)
      END

C  Differentiation of get_res in reverse (adjoint) mode (with options i4 dr8 r8):
C   gradient     of useful results: alfa beta vinf delcon xyzref
C                mach cdref rv1 rv2 rv rc gam gam_d res res_d wv_gam
C   with respect to varying inputs: ysym zsym alfa beta vinf parval
C                conval delcon xyzref mach cdref rv1 rv2 rv rc
C                chordv enc enc_d gam gam_d res res_d wv_gam
C   RW status of diff variables: ysym:out zsym:out alfa:in-out
C                beta:in-out vinf:in-out parval:out conval:out
C                delcon:in-out xyzref:in-out mach:in-zero cdref:in-zero
C                rv1:incr rv2:incr rv:incr rc:incr chordv:out enc:out
C                enc_d:out gam:incr gam_d:incr res:in-zero res_d:in-out
C                wv_gam:in-out
C
C ======================== res and Adjoint for GAM ========      
      SUBROUTINE GET_RES_B()
C
      INCLUDE 'AVL.INC'
      INCLUDE 'AVL_ad_seeds.inc'
      INTEGER i, ic
      REAL rhs_d(nvor)
      REAL rhs_d_diff(nvor)
      REAL betm
      REAL betm_diff
      INTRINSIC SQRT
      INTEGER ii1
      INTEGER ii2
      INTEGER ii3
      CALL SET_PAR_AND_CONS(nitmax, irun)
C Do not use this routine in the sovler
C IF(.NOT.LAIC) THEN
C      CALL build_AIC
C end if
C---  
      ! CALL PUSHREAL8ARRAY(wc_gam, 3*nvmax**2)
      ! CALL BUILD_AIC()
      amach = mach
      betm = SQRT(1.0 - amach**2)
C---- set VINF() vector from initial ALFA,BETA
      CALL VINFAB()
C
      DO ii1=1,3
        wrot_diff(ii1) = 0.D0
      ENDDO
      DO ii1=1,ndmax
        DO ii2=1,nvor
          DO ii3=1,3
            enc_d_diff(ii3, ii2, ii1) = 0.D0
          ENDDO
        ENDDO
      ENDDO
      DO ii1=1,nvor
        DO ii2=1,nvor
          aicn_diff(ii2, ii1) = 0.D0
        ENDDO
      ENDDO
      DO ii1=1,nvor
        rhs_d_diff(ii1) = 0.D0
      ENDDO
C$BWD-OF II-LOOP 
      DO ic=1,ncontrol
C------ don't bother if this control variable is undefined
        IF (lcondef(ic)) THEN
C$BWD-OF II-LOOP 
          DO i=1,nvor
            rhs_d_diff(i) = rhs_d_diff(i) - res_d_diff(i, ic)
          ENDDO
          CALL SET_GAM_D_RHS_B(ic, enc_d, enc_d_diff, rhs_d, rhs_d_diff)
          CALL MAT_PROD_B(aicn, aicn_diff, gam_d(:, ic), gam_d_diff(:, 
     +                    ic), nvor, res_d(:, ic), res_d_diff(:, ic))
          DO ii1=1,nvor
            res_d_diff(ii1, ic) = 0.D0
          ENDDO
        END IF
      ENDDO
      DO ii1=1,nvor
        rhs_diff(ii1) = 0.D0
      ENDDO
C$BWD-OF II-LOOP 
      DO i=1,nvor
        rhs_diff(i) = rhs_diff(i) - res_diff(i)
      ENDDO
      CALL MAT_PROD_B(aicn, aicn_diff, gam, gam_diff, nvor, res, 
     +                res_diff)
      DO ii1=1,nvor
        res_diff(ii1) = 0.D0
      ENDDO
      CALL SET_VEL_RHS_B()
      CALL VINFAB_B()
      ysym_diff = 0.D0
      zsym_diff = 0.D0
      DO ii1=1,nvor
        chordv_diff(ii1) = 0.D0
      ENDDO
      CALL VVOR_B(betm, betm_diff, iysym, ysym, ysym_diff, izsym, zsym, 
     +            zsym_diff, vrcore, nvor, rv1, rv1_diff, rv2, rv2_diff
     +            , nsurfv, chordv, chordv_diff, nvor, rv, rv_diff, 
     +            nsurfv, .true., wv_gam, wv_gam_diff, nvmax)
      IF (1.0 - amach**2 .EQ. 0.D0) THEN
        amach_diff = 0.D0
      ELSE
        amach_diff = -(2*amach*betm_diff/(2.0*SQRT(1.0-amach**2)))
      END IF
      mach_diff = mach_diff + amach_diff
      ! CALL POPREAL8ARRAY(wc_gam, 3*nvmax**2)
      CALL BUILD_AIC_B()
      CALL SET_PAR_AND_CONS_B(nitmax, irun)
      mach_diff = 0.D0
      cdref_diff = 0.D0
      END

