C        Generated by TAPENADE     (INRIA, Ecuador team)
C  Tapenade 3.16 (develop) - 15 Jan 2021 14:26
C
C  Differentiation of cdcl in reverse (adjoint) mode (with options i4 dr8 r8):
C   gradient     of useful results: cd_cl cd
C   with respect to varying inputs: cl
C***********************************************************************
C    Module:  cdcl.f
C 
C    Copyright (C) 2002 Mark Drela, Harold Youngren
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************
C
      SUBROUTINE CDCL_B(j, cl, cl_diff, cd, cd_diff, cd_cl, cd_cl_diff)
      INCLUDE 'AVL.INC'
      INCLUDE 'AVL_ad_seeds.inc'
      REAL clmin
      REAL cdmin
      REAL cl0
      REAL cd0
      REAL clmax
      REAL cdmax
      REAL cdx1
      REAL cdx2
      REAL clfac
      INTEGER j
      REAL clinc
      REAL cd_cl
      REAL cd_cl_diff
      REAL cd
      REAL cd_diff
      REAL cl
      REAL cl_diff
      REAL cdinc
C
C--- CLINC and CDINC control the rate of increase of drag in the stall regions
C    CLINC=0.2 forces drag to increase by CDINC over deltaCL=0.2 after stall
C    The CDINC term is the CD increment added by deltaCL=CLINC after stall
C
      DATA clinc, cdinc /0.2, 0.0500/
C
      IF (j .LT. 1 .OR. j .GT. nstrip) THEN
        cl_diff = 0.D0
      ELSE
C
C--- Unpack the CD,CL parameters for this strip
        clmin = clcd(1, j)
        cdmin = clcd(2, j)
        cl0 = clcd(3, j)
        cd0 = clcd(4, j)
        clmax = clcd(5, j)
        cdmax = clcd(6, j)
        IF (clmax .LE. cl0 .OR. cl0 .LE. clmin) THEN
          cl_diff = 0.D0
        ELSE
C
C--- Some matching parameters that make the slopes smooth at the stall joins
          cdx1 = 2.0*(cdmin-cd0)*(clmin-cl0)/(clmin-cl0)**2
          cdx2 = 2.0*(cdmax-cd0)*(clmax-cl0)/(clmax-cl0)**2
          clfac = 1.0/clinc
C
C--- Four formulas are used for CD, depending on the CL  
C
          IF (cl .LT. clmin) THEN
            cl_diff = clfac*cdinc*2.0*cd_cl_diff + (2*(cl-clmin)*cdinc*
     +        clfac**2-cdx1/(clmin-cl0))*cd_diff
          ELSE IF (cl .LT. cl0) THEN
            cl_diff = (cdmin-cd0)*2.0*cd_cl_diff/(clmin-cl0)**2 + 2*(cl-
     +        cl0)*(cdmin-cd0)*cd_diff/(clmin-cl0)**2
          ELSE IF (cl .LT. clmax) THEN
            cl_diff = (cdmax-cd0)*2.0*cd_cl_diff/(clmax-cl0)**2 + 2*(cl-
     +        cl0)*(cdmax-cd0)*cd_diff/(clmax-cl0)**2
          ELSE
            cl_diff = clfac*cdinc*2.0*cd_cl_diff + (2*(cl-clmax)*cdinc*
     +        clfac**2+cdx2/(clmax-cl0))*cd_diff
          END IF
        END IF
      END IF
      END
C
C
C
C
C
C
C

